program roborace_cli;
uses sockets,crt,sysutils,strings;

procedure error(const s: string);
begin
  writeln(s,socketerror);
  halt(1);
end;

// prevedeni ip na hex; vysledek je 4 byte, tzn. dword (double word)
function ip2hex(c1,c2,c3,c4: byte): dword;
begin
	ip2hex := ((c1*256+c2)*256+c3)*256+c4;
end;

// procedura pro konec hry
procedure konechry(kod: string);
begin
	writeln(kod);
	halt(1);
end;

// mazani mezery na konci stringu
function smazmezeru(s: string): string;
var l,p,f:	byte;
begin
	p := length(s);
	f := 1;
	while ((P > 0) and (s[p] = ' ')) do dec(p);
	while ((f <= length(s)) and (s[f] = ' ')) do inc(f);
	l := p-f+1;
	if (l > 0) then smazmezeru := copy(s,f,l) else smazmezeru := '';
end;

var
	r_ori:		string; // orientace robota
	r_pols:		integer; // poloha robota v sloupcich
	r_polr:		integer; // poloha robota v radcich
	r_temp:		string; // docasna promenna se vsim

	mapa:		array[1..20,1..20] of string; // cela mapa
	mapa_b:		array[1..20] of string;
	r_pohyby:	array[1..9] of char; // mozne pohyby
	m_pole:		array[1..4] of char; // mozna policka mapy
	
	uv_pohyby:	string; // pohyby ktere navolil uzivatel
	ident_s:	string; // string identifikace

	// promenne pro cykly
	i1:			integer;

	// promenne pro praci se socketem
	ip:			array[1..4] of byte;
	port:		longint;
	saddr:		tinetsockaddr;
	buffer:		array[1..23] of string[255];
	s:			longint;
	sin,sout:	text;

begin
	// spusteni programu, uvitani
	clrscr;
	writeln('Vitejte v RoboRace klientovi.');
	writeln('Nyni prosim zadejte IP adresu serveru. Kazdou cast adresy neoddelujte teckou, ale enterem!');
	readln(ip[1]);
	gotoxy(4,wherey-1);
	write('.');
	readln(ip[2]);
	gotoxy(7,wherey-1);
	write('.');
	readln(ip[3]);
	gotoxy(10,wherey-1);
	write('.');
	readln(ip[4]);
	writeln('Nyni prosim zapiste port serveru, potvrdte opet enterem');
	readln(port);
	// konec uvitani

	// nastaveni socketu
	s := fpsocket(2,1,0);
	port := htons(port); // jakasi prapodivna procedura s cislem portu
	if (s = -1) then error('Client : Socket : ');
	saddr.sin_family := 2; // nastaveni pouzivani internetu
	saddr.sin_port := port; // nastaveni portu
	saddr.sin_addr.s_addr := hosttonet(ip2hex(ip[1],ip[2],ip[3],ip[4])); // prevedeni ip na hex a prevraceni
	// konec nastaveni socketu

	// zacatek pripojeni na server a zahajeni hry
	if not connect(s,saddr,sin,sout) then error('Client : Connect : ');
	reset(sin);
	rewrite(sout);
	writeln(sout,'GET /start');
	flush(sout);
	for i1 := 1 to 23 do
	begin
		readln(sin,buffer[i1]);
	end;
	close(sout);
	// konec pripojovani a zahajovani, nasleduje zpracovani vystupu

	// zacatek zpracovani vystupu
	ident_s := buffer[1]; // identifikator hry
	r_pohyby := buffer[23]; // mozne pohyby
	for i1 := 2 to 21 do // vlozeni mapy do promenne at neni porad v bufferu, tam ji premazu
	begin
		mapa_b[i1-1] := buffer[i1];
	end;
	r_temp := buffer[22];
	(* sem patri jeste rozrezani souradnic a orientace od tohohle stringu *)
	// konec zpracovani vystupu

	// a uz hrajem
	clrscr;
	// vypsani mapy a zakresleni pozice hrace
	writeln('Mapa: ');
	for i1 := 1 to 20 do
	begin
		writeln(mapa_b[i1]); // vypsani mapy
	end;

	while (1 = 1) do
	begin
		// pripojeni k serveru
		s := fpsocket(2,1,0);
		if (s = -1) then error('Client : Socket : ');
		if not connect(s,saddr,sin,sout) then error('Client : Connect : ');
		reset(sin);
		rewrite(sout);
		write('Zvolenych 5 pohybu ['+r_pohyby+']: ');readln(uv_pohyby);
		writeln(sout,'GET /kolo?id='+ident_s+'&pohyby='+uv_pohyby);

		// prijmuti od serveru
		for i1 := 1 to 23 do
		begin
			readln(sin,buffer[i1]);
			
			// pokud chyba/vyhra tak konec
			if (copy(buffer[i1],0,5) = 'Chyba') then
			begin
				close(sout);
				konechry(buffer[i1]) ;
			end
			else
			begin
				if (copy(buffer[i1],0,5) = 'Vyhra') then
				begin
					close(sout);
					konechry(buffer[i1]);
				end;
			end;
			
			// zapsani vystupu
			readln(sin,buffer[i1]);
		end;
		// zpracovani vystupu
		ident_s := buffer[1]; // identifikator hry
		r_pohyby := buffer[23]; // mozne pohyby
		for i1 := 2 to 21 do // vlozeni mapy do promenne at neni porad v bufferu, tam ji premazu
		begin
			mapa_b[i1-1] := buffer[i1];
		end;
		r_temp := buffer[23];
		
		clrscr;
		// vypsani mapy a zakresleni pozice hrace
		writeln('Souradnice Leraka: '+copy(r_temp,0,length(r_temp)-1));
		writeln('Rotace Leraka: '+copy(r_temp,length(r_temp)-1,length(r_temp)));
		for i1 := 1 to 20 do
		begin
			writeln(mapa_b[i1]);
		end;
	end;
end.
